<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des catégories socio-professionnelles n'ont pas pu être chargées."
    />
    <template v-else-if="CSPCounts">
      <h2 class="fr-h5">Catégories socio-professionnelles</h2>
      <StatsList
        v-if="CSPCounts.length"
        :total-count="beneficiaryCount"
        :stats="CSPCounts"
        stats-bar
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des catégories
        socio-professionnelles.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { SOCIO_PROFESSIONAL_CATEGORY_OPTIONS } from '~/utils/constants/beneficiary'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~~/utils/stats'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: CSPCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData('CSPCounts', loadCSPCounts, {
    server: false
  })

  watch(() => props.filters, refresh)

  async function loadCSPCounts() {
    const res = await $getItems('beneficiary', {
      groupBy: 'socio_professional_category',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const CSPResCounts = res.data.data.map(CSP => ({
        key: CSP.socio_professional_category,
        label: labelOrUnprovided(
          CSP.socio_professional_category,
          SOCIO_PROFESSIONAL_CATEGORY_OPTIONS
        ),
        count: parseInt(CSP.countDistinct.id)
      }))
      CSPResCounts.sort((a, b) => b.count - a.count)
      return CSPResCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
